# Builder Configurations
# --------------------------------
# YAML file containing compilation flags and builder definitions.
# For details, please refer to the README.md

# TODOs
# ----------------
# (Alex) Issue 32. Relocate ENV Vars (environment_variables field) to Workers
# (Alex) Issue 33. Add mpiexec to this file, and write a parser for it


environment_variables:
  buildbot_modulecmd: &buildbot_modulecmd '/usr/share/lmod/lmod/libexec/lmod'
  foss_2021a_prefix: "/opt_buildbot/linux-debian11/sandybridge/EasyBuild/2021a/software"
  foss_mpiexec: &foss_mpiexec "${EBROOTOPENMPI}/bin/mpiexec --map-by socket"
  intel_mpiexec: &intel_mpiexec "${EBROOTIMPI}/mpi/latest/bin/mpirun --map-by socket"

optional_builder_defaults:
  variant: 'full'
  mpi: False
  cuda: False
  test: 'full'
  timeout: 1800
  testCommand:
  modulecmd: *buildbot_modulecmd
  codeCoverage: False
  valgrind: False
  failOnCompilerWarnings: False

# Builder flags
# Order of definitions matters, as `pm` flags used in `foss` and `intel` flag definitions

flags:
  # Package manager: Easybuild (eb) or Spack (spack)
  pm:
    configure_flags_min: '--with-libxc-prefix=$PMROOT_LIBXC --with-gsl-prefix=$PMROOT_GSL --enable-silent_deprecation'
    configure_flags_common: '--with-netcdf-prefix=$PMROOT_NETCDFMINFORTRAN
                              --with-etsf-io-prefix=$PMROOT_ETSF_IO
                              --with-sparskit=$PMROOT_SPARSKIT2/lib/libskit.a
                              --with-nlopt-prefix=$PMROOT_NLOPT
                              --with-dftbplus-prefix=$PMROOT_DFTBPLUS
                              --with-psolver-prefix=$PMROOT_PSOLVER
                              --with-futile-prefix=$PMROOT_FUTILE
                              --with-pspio-prefix=$PMROOT_LIBPSPIO'
#                              --with-berkeleygw-prefix=$PMROOT_BERKELEYGW
    configure_flags_valgrind: '--with-netcdf-prefix=$PMROOT_NETCDFMINFORTRAN
                              --with-etsf-io-prefix=$PMROOT_ETSF_IO
                              --with-sparskit=$PMROOT_SPARSKIT2/lib/libskit.a
                              --with-nlopt-prefix=$PMROOT_NLOPT
                              --with-psolver-prefix=$PMROOT_PSOLVER
                              --with-futile-prefix=$PMROOT_FUTILE
                              --with-pspio-prefix=$PMROOT_LIBPSPIO'
    configure_flags_mpi: '--enable-mpi --with-elpa-prefix=$PMROOT_ELPA'
    configure_flags_omp: '--enable-openmp'
    configure_flags_blas: '--with-blas="-L$BLAS_LIB_DIR $LIBBLAS"'
    configure_flags_blas_mt: '--with-blas="-L$BLAS_LIB_DIR $LIBBLAS_MT"'
    configure_flags_blacs: '--with-blacs="-L$SCALAPACK_LIB_DIR $LIBSCALAPACK"'
    configure_flags_blacs_mt: '--with-blacs="-L$SCALAPACK_LIB_DIR $LIBSCALAPACK_MT"'

  foss:
    cflags_debug: '-g -Wall -O2 -march=native -Wextra -pedantic'
    cflags: '-Wall -O2 -march=native'
    cflags_opt: '-Wall -O3 -march=native -funroll-loops'
    cflags_warnings: '-O0 -Wall -Wno-unknown-pragmas'
    cflags_mt: '-Wall -O3 -march=native -funroll-loops'

    cxxflags_debug: '-g -Wall -O2 -march=native -Wextra -pedantic'
    cxxflags: '-Wall -O2 -march=native'
    cxxflags_opt: '-Wall -O3 -march=native -funroll-loops'
    cxxflags_warnings: '-O0 -Wall -Wno-int-to-pointer-cast -Wno-switch -Wno-sign-compare -Wno-return-type -Wno-catch-value'
    cxxflags_mt: '-Wall -O2 -march=native'

    fflags_debug: '-g -fno-var-tracking-assignments -Wall -Wno-maybe-uninitialized -Wno-surprising -O2 -march=native -fbacktrace -fcheck=all -fbounds-check -finit-real=snan -finit-logical=false -finit-derived -ffpe-trap=zero,invalid'
    fflags_debug_mpi: '-g -fno-var-tracking-assignments -Wall -Wno-maybe-uninitialized -Wno-surprising -O2 -march=native -fbacktrace -fcheck=all -fbounds-check -finit-real=snan -ffpe-trap=zero,invalid'
    fflags: '-Wall -Wno-maybe-uninitialized -Wno-surprising -O2 -march=native -fbacktrace'
    fflags_opt: '-Wall -Wno-maybe-uninitialized -Wno-surprising -O3 -march=native -fbacktrace -funroll-loops'
    fflags_warnings: '-O0 -Wall -Wno-maybe-uninitialized -Wno-unused-dummy-argument -Wno-c-binding-type -Wno-surprising'
    fflags_strict: '-Wall -Wno-maybe-uninitialized -Wno-surprising -O2 -march=native -fbacktrace -finit-real=snan -ffpe-trap=invalid'
    fflags_mt: '-Wall -Wno-maybe-uninitialized -Wno-surprising -O3 -march=native -fbacktrace -funroll-loops'
    fflags_valgrind: '-g -fno-var-tracking-assignments -Wall -Wno-maybe-uninitialized -Wno-surprising -O2 -march=native -fbacktrace -fcheck=all -fbounds-check -ffpe-trap=zero,invalid'

    fcflags_elpa: '-I${EBROOTELPA}/include/elpa-${EBVERSIONELPA}/modules'

    ppc_cflags: '-Wall -O2 -mcpu=native'
    ppc_cxxflags: '-Wall -O2 -mcpu=native'
    ppc_fflags: '-Wall -Wno-maybe-uninitialized -Wno-surprising -O2 -mcpu=native -fbacktrace -fcheck=all -fbounds-check'

    cuda_cflags: '-Wall -O2 -march=native'
    cuda_cxxflags: '-Wall -O2 -march=native'
    cuda_fflags: '-Wall -O2 -march=native -fbacktrace -Wno-maybe-uninitialized -Wno-surprising'

    configure_flags_min: '{pm.configure_flags_min} {pm.configure_flags_blas} --with-fftw-prefix=$PMROOT_FFTW'
    configure_flags_min_mpi: '{foss.configure_flags_min} {pm.configure_flags_mpi}'
    configure_flags_common: '{pm.configure_flags_min} {pm.configure_flags_common} --with-fftw-prefix=$PMROOT_FFTW
                             --with-poke-prefix=$PMROOT_POKE --with-nfft=$PMROOT_NFFT --with-libvdwxc-prefix=$PMROOT_LIBVDWXC'
    configure_flags_mpi_common: '{foss.configure_flags_common} {pm.configure_flags_mpi} --with-pfft-prefix=$PMROOT_PFFT
                                 --with-pnfft-prefix=$PMROOT_PNFFT'
    configure_flags_serial: '{foss.configure_flags_common} {pm.configure_flags_blas}'
    configure_flags_valgrind: '{pm.configure_flags_min} {pm.configure_flags_valgrind} {pm.configure_flags_blas} --with-fftw-prefix=$PMROOT_FFTW
                             --with-poke-prefix=$PMROOT_POKE --with-nfft=$PMROOT_NFFT --with-libvdwxc-prefix=$PMROOT_LIBVDWXC'
    configure_flags_mt: '{foss.configure_flags_common} {pm.configure_flags_omp} {pm.configure_flags_blas_mt}'
    configure_flags_mpi: '{foss.configure_flags_mpi_common} {pm.configure_flags_blas} {pm.configure_flags_blacs}'
    configure_flags_mpi_mt: '{foss.configure_flags_mpi_common} {pm.configure_flags_blas_mt} {pm.configure_flags_omp}
                             {pm.configure_flags_blacs_mt}'
    cuda_configure_flags_common: '{pm.configure_flags_min} {pm.configure_flags_common} {pm.configure_flags_blas}
                                  --with-fftw-prefix=$PMROOT_FFTW
                                  --enable-cuda --with-cuda-prefix=$PMROOT_CUDA --with-poke-prefix=$PMROOT_POKE --with-nfft=$PMROOT_NFFT
                                  --with-libvdwxc-prefix=$PMROOT_LIBVDWXC'
    cuda_configure_flags_serial: '{foss.cuda_configure_flags_common}'
    cuda_configure_flags_mpi: '{foss.configure_flags_mpi} --enable-cuda --with-cuda-prefix=$PMROOT_CUDA'
    cuda_configure_flags_mpi_mt: '{foss.configure_flags_mpi_mt} --enable-cuda --with-cuda-prefix=$PMROOT_CUDA'

  intel:
    cflags: '-O3 -xHost -ftz -fp-speculation=safe -fp-model source -traceback -Wall'
    cflags_debug: '-O2 -traceback -Wall -g -check=uninit,stack,conversions -debug all'
    cflags_warnings: '-O0 -Wall -Wno-unknown-pragmas -diag-disable:167' # warning 167 occurs in spglib
    cxxflags: '-O3 -xHost -ftz -fp-speculation=safe -fp-model source -traceback -Wall'
    cxxflags_debug: '-O2 -xHost -traceback -Wall -g -check=uninit,stack,conversions -debug all'
    cxxflags_warnings: '-O0 -Wall -Wno-int-to-pointer-cast -Wno-switch -Wno-sign-compare -Wno-return-type'
    fflags: '-O3 -xHost -ftz -fp-speculation=safe -fp-model source -traceback -warn all'
    fflags_warnings: '-O0 -warn all,noexternals -diag-disable:5462,6843'
#    fflags_debug: '-O2 -traceback -g -fpe0 -check shape,bounds,uninit,contiguous,pointers,stack -debug all -warn all -gen-interfaces -warn interfaces'
    fflags_debug: '-O2 -traceback -g -fpe0 -check bounds,uninit -debug all -warn all -gen-interfaces -warn interfaces'
    fccpp: 'cpp'
    fcflags_fftw: "-I${PMROOT_IMKL}/mkl/include/fftw"
    fcflags_elpa: '-I${EBROOTELPA}/include/elpa-${EBVERSIONELPA}/modules'
    configure_flags_common: '{pm.configure_flags_min} {pm.configure_flags_common} --disable-gdlib --with-max-dim=4'
    configure_flags_serial: '{intel.configure_flags_common} {pm.configure_flags_blas}'
    configure_flags_mt: '{intel.configure_flags_common} {pm.configure_flags_omp} {pm.configure_flags_blas_mt}'
    configure_flags_mpi: '{intel.configure_flags_common} {pm.configure_flags_blas} {pm.configure_flags_mpi} {pm.configure_flags_blacs} --enable-mpi_mod'
    configure_flags_mpi_mt: '{intel.configure_flags_common} {pm.configure_flags_blas_mt} {pm.configure_flags_mpi} {pm.configure_flags_omp} {pm.configure_flags_blacs_mt} --enable-mpi_mod'
  spack:
    configure_flags_mpi_omp: '{foss.configure_flags_mpi_mt} --with-atlab-prefix=$PMROOT_ATLAB'
    configure_flags_mpi: '{foss.configure_flags_mpi} --with-atlab-prefix=$PMROOT_ATLAB --with-sparskit=-L"$MPSD_SPARSKIT_ROOT/lib" '
    configure_flags_serial_omp: '{foss.configure_flags_mt} --with-atlab-prefix=$PMROOT_ATLAB'
    configure_flags_serial: '{foss.configure_flags_serial} --with-atlab-prefix=$PMROOT_ATLAB --with-sparskit=-L"$MPSD_SPARSKIT_ROOT/lib" '
    configure_flags_serial_min: '{foss.configure_flags_min} --disable-gdlib --disable-cgal --disable-sparskit'
    cuda_configure_flags_mpi_mt: '{foss.cuda_configure_flags_mpi_mt} --with-atlab-prefix=$PMROOT_ATLAB'
    cuda_configure_flags_mpi: '{foss.cuda_configure_flags_mpi} --with-atlab-prefix=$PMROOT_ATLAB'
    cuda_configure_flags_serial: '{foss.cuda_configure_flags_serial} --with-atlab-prefix=$PMROOT_ATLAB'
    configure_flags_valgrind: '{foss.configure_flags_valgrind} --with-atlab-prefix=$PMROOT_ATLAB'
    # configure_flags_ppc: '{spack.configure_flags_serial} --with-blas="-L$PMROOT_OPENBLAS -lopenblas -pthread" --with-atlab-prefix=$PMROOT_ATLAB'
    configure_flags_ppc: '{foss.configure_flags_common} --with-blas="-L$PMROOT_OPENBLAS -lopenblas -pthread" --with-atlab-prefix=$PMROOT_ATLAB --without-cgal'
    configure_flags_mpi_min: '{foss.configure_flags_min_mpi} --disable-gdlib --without-cgal --disable-sparskit'


# Builders

# Easybuild builder examples
EB:
  foss:

    # ---- 2021a ----

    2021a_warnings:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_warnings}'
        CXXFLAGS: '{foss.cxxflags_warnings}'
        FCFLAGS: '{foss.fflags_warnings}'
        LOCAL_MAKEFLAGS: '-j 16 -s'
        LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'
      test: 'none'
      variant: 'warnings'
      failOnCompilerWarnings: True

    2021a_warnings_mpi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_warnings}'
        CXXFLAGS: '{foss.cxxflags_warnings}'
        FCFLAGS: '{foss.fflags_warnings}'
        FCFLAGS_ELPA: '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16 -s'
        LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_mpi}'
      test: 'none'
      variant: 'warnings'
      mpi: True
      failOnCompilerWarnings: True

    2021a_debug:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_debug}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'
      codeCoverage: True

    2021a_valgrind:
      workers:
        - !WorkerGroup 'fat_tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_valgrind}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 32
        OMP_NUM_THREADS: 1
      flags: '{foss.configure_flags_serial}'
      test: 'short'
      valgrind: True
      codeCoverage: True

    2021a_valgrind_long:
      workers:
        - !WorkerGroup 'fat_tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_valgrind}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 32
        OMP_NUM_THREADS: 1
      flags: '{foss.configure_flags_serial}'
      test: 'long'
      valgrind: True
      codeCoverage: True

    2021a_ppc:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_common} --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'
    2021a_ppc_mpi:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags} -fallow-argument-mismatch'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 12
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi_common}  --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'
      mpi: True

    2021a_ppc_min:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
        EASYBUILD_PREFIX: "/opt_buildbot/${MPSD_OS}/${MPSD_MICROARCH}/EasyBuild_TEST/"
      flags: '{foss.configure_flags_min} --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'
      variant: 'min'

    2021a_ppc_min_mpi:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags} -fallow-argument-mismatch'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 12
        EASYBUILD_PREFIX: "/opt_buildbot/${MPSD_OS}/${MPSD_MICROARCH}/EasyBuild_TEST/"
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_min_mpi}  --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'
      mpi: True
      variant: 'min'

    # ---- 2021b ----

    2021b:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'

    2021b_mpi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags}'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi}'
      mpi: True

    # ---- 2022a ----

    2022a:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'
      codeCoverage: True

    2022a_mpi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi}'
      mpi: True
      codeCoverage: True

    2022a_min:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_min}'
      codeCoverage: True
      variant: 'min'

    2022a_mpi_min:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_min_mpi}'
      mpi: True
      codeCoverage: True
      variant: 'min'

    2022a_opt:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_opt}'
        CXXFLAGS: '{foss.cxxflags_opt}'
        FCFLAGS: '{foss.fflags_opt}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'

    2022a_mpi_opt:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_opt}'
        CXXFLAGS: '{foss.cxxflags_opt}'
        FCFLAGS: '{foss.fflags_opt} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi}'
      mpi: True

    2022a_omp:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
        OMP_NUM_THREADS: 2
      flags: '{foss.configure_flags_mt}'

    2022a_mpi_omp:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        OMP_NUM_THREADS: 2
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi_mt}'
      mpi: True

    2022a_warnings:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_warnings}'
        CXXFLAGS: '{foss.cxxflags_warnings}'
        FCFLAGS: '{foss.fflags_warnings}'
        LOCAL_MAKEFLAGS: '-j 16 -s'
        LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'
      test: 'none'
      variant: 'warnings'
      failOnCompilerWarnings: True

    2022a_warnings_mpi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_warnings}'
        CXXFLAGS: '{foss.cxxflags_warnings}'
        FCFLAGS: '{foss.fflags_warnings}'
        FCFLAGS_ELPA: '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16 -s'
        LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_mpi}'
      test: 'none'
      variant: 'warnings'
      mpi: True
      failOnCompilerWarnings: True

    2022a_debug:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_debug}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
        OCT_DEBUGTRAPSIGNALS : 'no'
      flags: '{foss.configure_flags_serial}'
      variant: 'debug'
      codeCoverage: True

    2022a_debug_trace:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_debug}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
        OCT_DEBUGTRAPSIGNALS : 'no'
        OCT_DEBUG: 'trace + info'
        OCT_MPIDEBUGHOOK: 'no'
      flags: '{foss.configure_flags_serial}'
      variant: 'debug'
      codeCoverage: True


    2022a_debug_j1:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_debug}'
        LOCAL_MAKEFLAGS: '-j 1'
        OCT_TEST_NJOBS: 16
        OCT_DEBUGTRAPSIGNALS : 'no'
      flags: '{foss.configure_flags_serial}'
      variant: 'debug'
      codeCoverage: True

    2022a_mpi_debug:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        CPPFLAGS: '-DINIT_BATCH'
        FCFLAGS: '{foss.fflags_debug_mpi} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
        OCT_DEBUGTRAPSIGNALS : 'no'
      flags: '{foss.configure_flags_mpi}'
      mpi: True
      variant: 'debug'
      codeCoverage: True

    2022a_bgw3_mpi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LIBS_BERKELEYGW : '-L$EBROOTBERKELEYGW/lib -lBGW_wfn -lgomp'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi} --with-berkeleygw-prefix="-L$EBROOTBERKELEYGW"'
      mpi: True
      variant: 'bgw3'
      codeCoverage: True


    # PPC builders

    2022a_ppc:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_common} --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'

    2022a_ppc_min:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_min} --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'
      variant: 'min'

    2022a_ppc_mpi:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 12
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi_common}  --with-parmetis-prefix=no --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'
      mpi: True

    2022a_ppc_min_mpi:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 12
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_min_mpi}  --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'
      mpi: True
      variant: 'min'

    # Valgrind builders:

    2022a_valgrind:
      workers:
        - !WorkerGroup 'fat_tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_valgrind}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 32
        OMP_NUM_THREADS: 1
      flags: '{foss.configure_flags_valgrind} --without-cgal  --without-dftbplus'
      test: 'short'
      valgrind: True
      codeCoverage: True

    2022a_valgrind_long:
      workers:
        - !WorkerGroup 'fat_tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_valgrind}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 32
        OMP_NUM_THREADS: 1
      flags: '{foss.configure_flags_serial} --without-cgal'
      test: 'long'
      valgrind: True
      codeCoverage: True

    # ---- 2022b ----

    2022b:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'
      codeCoverage: True

    2022b_mpi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi}'
      mpi: True
      codeCoverage: True

    2022b_libxc6:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'
      variant: 'libxc6'
      codeCoverage: True

    2022b_libxc6_mpi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi}'
      mpi: True
      variant: 'libxc6'
      codeCoverage: True

    2022b_opt:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_opt}'
        CXXFLAGS: '{foss.cxxflags_opt}'
        FCFLAGS: '{foss.fflags_opt}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'

    2022b_mpi_opt:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_opt}'
        CXXFLAGS: '{foss.cxxflags_opt}'
        FCFLAGS: '{foss.fflags_opt} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi}'
      mpi: True

    2022b_omp:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
        OMP_NUM_THREADS: 2
      flags: '{foss.configure_flags_mt}'

    2022b_mpi_omp:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        OMP_NUM_THREADS: 2
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi_mt}'
      mpi: True

    2022b_warnings:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_warnings}'
        CXXFLAGS: '{foss.cxxflags_warnings}'
        FCFLAGS: '{foss.fflags_warnings}'
        LOCAL_MAKEFLAGS: '-j 16 -s'
        LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_serial}'
      test: 'none'
      variant: 'warnings'
      failOnCompilerWarnings: True

    2022b_warnings_mpi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_warnings}'
        CXXFLAGS: '{foss.cxxflags_warnings}'
        FCFLAGS: '{foss.fflags_warnings}'
        FCFLAGS_ELPA: '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16 -s'
        LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_mpi}'
      test: 'none'
      variant: 'warnings'
      mpi: True
      failOnCompilerWarnings: True

    2022b_debug:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_debug}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
        OCT_DEBUGTRAPSIGNALS : 'no'
      flags: '{foss.configure_flags_serial}'
      variant: 'debug'
      codeCoverage: True

    2022b_debug_trace:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_debug}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
        OCT_DEBUGTRAPSIGNALS : 'no'
        OCT_DEBUG: 'trace + info'
        OCT_MPIDEBUGHOOK: 'no'
      flags: '{foss.configure_flags_serial}'
      variant: 'debug'
      codeCoverage: True


    2022b_debug_j1:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        FCFLAGS: '{foss.fflags_debug}'
        LOCAL_MAKEFLAGS: '-j 1'
        OCT_TEST_NJOBS: 16
        OCT_DEBUGTRAPSIGNALS : 'no'
      flags: '{foss.configure_flags_serial}'
      variant: 'debug'
      codeCoverage: True

    2022b_mpi_debug:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        CPPFLAGS: '-DINIT_BATCH'
        FCFLAGS: '{foss.fflags_debug_mpi} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
        OCT_DEBUGTRAPSIGNALS : 'no'
      flags: '{foss.configure_flags_mpi}'
      mpi: True
      variant: 'debug'
      codeCoverage: True

    2022b_bgw3_mpi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LIBS_BERKELEYGW : '-L$EBROOTBERKELEYGW/lib -lBGW_wfn -lgomp'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_mpi} --with-berkeleygw-prefix="-L$EBROOTBERKELEYGW"'
      mpi: True
      variant: 'bgw3'
      codeCoverage: True

    2022b_ppc_min:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{foss.configure_flags_min} --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'
      variant: 'min'

    2022b_ppc_min_mpi:
      workers:
        - !WorkerGroup 'power_tentacles'
      var:
        CFLAGS: '{foss.ppc_cflags}'
        CXXFLAGS: '{foss.ppc_cxxflags}'
        FCFLAGS: '{foss.ppc_fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{foss.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 12
        MPIEXEC: *foss_mpiexec
      flags: '{foss.configure_flags_min_mpi}  --with-blas="-L$EBROOTOPENBLAS -lopenblas -pthread"'
      mpi: True
      variant: 'min'


  fosscuda:

    2022a:
      workers:
        - !WorkerGroup 'accelerated_tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 20
      flags: '{foss.cuda_configure_flags_serial}'
      cuda: True
      codeCoverage: True

    2022a_mpi:
      workers:
        - !WorkerGroup 'accelerated_tentacles'
      var:
        CFLAGS: '{foss.cflags}'
        CXXFLAGS: '{foss.cxxflags}'
        FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 10
        UCX_TLS: 'self,sm,cuda_ipc,gdr_copy,rc'
        MPIEXEC: *foss_mpiexec
      flags: '{foss.cuda_configure_flags_mpi}'
      cuda: True
      mpi: True
      codeCoverage: True

    2022a_mpi_omp:
      workers:
        - !WorkerGroup 'accelerated_tentacles'
      var:
        CFLAGS: '{foss.cflags_mt}'
        CXXFLAGS: '{foss.cxxflags_mt}'
        FCFLAGS: '{foss.fflags_mt} -fallow-argument-mismatch'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 10
        UCX_TLS: 'self,sm,cuda_ipc,gdr_copy,rc'
        OMP_NUM_THREADS: 2
        MPIEXEC: *foss_mpiexec
      flags: '{foss.cuda_configure_flags_mpi_mt}'
      cuda: True
      mpi: True


    2022a_mpi_debug:
      workers:
        - !WorkerGroup 'accelerated_tentacles'
      var:
        CFLAGS: '{foss.cflags_debug}'
        CXXFLAGS: '{foss.cxxflags_debug}'
        CPPFLAGS: ' -DINIT_BATCH'
        FCFLAGS: '{foss.fflags_debug} -fallow-argument-mismatch'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 10
        OMP_NUM_THREADS: 1
        OCT_DEBUGTRAPSIGNALS : 'no'
        UCX_TLS: 'self,sm,cuda_ipc,gdr_copy,rc'
        MPIEXEC: *foss_mpiexec
      flags: '{foss.cuda_configure_flags_mpi}'
      cuda: True
      mpi: True
      codeCoverage: True


  intel:
    2022a:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{intel.cflags}'
        CXXFLAGS: '{intel.cxxflags}'
        FCFLAGS: '{intel.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{intel.configure_flags_serial}'

    2022a_impi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{intel.cflags}'
        CXXFLAGS: '{intel.cxxflags}'
        FCFLAGS: '{intel.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{intel.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        OMP_NUM_THREADS: 1
        MPIEXEC: *intel_mpiexec
      flags: '{intel.configure_flags_mpi}'
      mpi: True

    2022a_omp:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{intel.cflags}'
        CXXFLAGS: '{intel.cxxflags}'
        FCFLAGS: '{intel.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        OMP_NUM_THREADS : 2
      flags: '{intel.configure_flags_mt}'

    2022a_omp_impi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{intel.cflags}'
        CXXFLAGS: '{intel.cxxflags}'
        FCFLAGS: '{intel.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{intel.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 4
        OMP_NUM_THREADS: 2
        MPIEXEC: *intel_mpiexec
      flags: '{intel.configure_flags_mpi_mt}'
      mpi: True

    2022a_debug:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        CFLAGS: '{intel.cflags_debug}'
        CXXFLAGS: '{intel.cxxflags_debug}'
        FCFLAGS: '{intel.fflags_debug}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{intel.configure_flags_serial}'

    # 2022b

    2022b:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        FC: 'ifort'
        CC: 'icc'
        CXX: 'icpc'
        CFLAGS: '{intel.cflags}'
        CXXFLAGS: '{intel.cxxflags}'
        FCFLAGS: '{intel.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{intel.configure_flags_serial}'

    2022b_impi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        FC: 'mpiifort'
        CC: 'mpiicc'
        CXX: 'mpiicpc'
        CFLAGS: '{intel.cflags}'
        CXXFLAGS: '{intel.cxxflags}'
        FCFLAGS: '{intel.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{intel.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        OMP_NUM_THREADS: 1
        MPIEXEC: *intel_mpiexec
      flags: '{intel.configure_flags_mpi}'
      mpi: True

    2022b_omp:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        FC: 'ifort'
        CC: 'icc'
        CXX: 'icpc'
        CFLAGS: '{intel.cflags}'
        CXXFLAGS: '{intel.cxxflags}'
        FCFLAGS: '{intel.fflags}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 8
        OMP_NUM_THREADS : 2
      flags: '{intel.configure_flags_mt}'

    2022b_omp_impi:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        FC: 'mpiifort'
        CC: 'mpiicc'
        CXX: 'mpiicpc'
        CFLAGS: '{intel.cflags}'
        CXXFLAGS: '{intel.cxxflags}'
        FCFLAGS: '{intel.fflags} -fallow-argument-mismatch'
        FCFLAGS_ELPA : '{intel.fcflags_elpa}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 4
        OMP_NUM_THREADS: 2
        MPIEXEC: *intel_mpiexec
      flags: '{intel.configure_flags_mpi_mt}'
      mpi: True

    2022b_debug:
      workers:
        - !WorkerGroup 'tentacles'
      var:
        FC: 'ifort'
        CC: 'icc'
        CXX: 'icpc'
        CFLAGS: '{intel.cflags_debug}'
        CXXFLAGS: '{intel.cxxflags_debug}'
        FCFLAGS: '{intel.fflags_debug}'
        LOCAL_MAKEFLAGS: '-j 16'
        OCT_TEST_NJOBS: 16
      flags: '{intel.configure_flags_serial}'

templates:
  spack_env_vars_libs: &spack_env_vars_libs
    BLAS_LIB_DIR: '${MPSD_OPENBLAS_ROOT}/lib'
    LIBBLAS: '-lopenblas'
    LIBBLAS_MT: '-lopenblas'
  spack_env_vars_libs_mpi: &spack_env_vars_libs_mpi
    FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2021.11.001/modules'
    LIBS_ELPA: "-lelpa_openmp"
    SCALAPACK_LIB_DIR: '${MPSD_NETLIB_SCALAPACK_ROOT}/lib'
    LIBSCALAPACK_MT: '-lscalapack'
    LIBSCALAPACK: '-lscalapack'

  spack_intel_env_vars_libs: &spack_intel_env_vars_libs
    <<: *spack_env_vars_libs
    BLAS_LIB_DIR: '${MPSD_INTEL_ONEAPI_MKL_ROOT}/lib/intel64'
    LIBBLAS: '-Wl,-Bstatic -Wl,--start-group -lmkl_intel_lp64 -lmkl_sequential -lmkl_core -Wl,--end-group -Wl,-Bdynamic'
    LIBBLAS_MT: '-Wl,-Bstatic -Wl,--start-group -lmkl_intel_lp64 -lmkl_intel_thread -lmkl_core -Wl,--end-group -Wl,-Bdynamic'

  spack_intel_env_vars_libs_mpi: &spack_intel_env_vars_libs_mpi
    <<: *spack_env_vars_libs_mpi
    FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2021.11.001/modules'
    LIBS_ELPA: "-lelpa_openmp"
    SCALAPACK_LIB_DIR: '${MPSD_INTEL_ONEAPI_MKL_ROOT}/lib/intel64'
    LIBBLAS: '-Wl,-Bstatic -Wl,--start-group -lmkl_intel_lp64 -lmkl_sequential -lmkl_core -Wl,--end-group -Wl,-Bdynamic'
    LIBBLAS_MT: '-Wl,-Bstatic -Wl,--start-group -lmkl_intel_lp64 -lmkl_intel_thread -lmkl_core -Wl,--end-group -Wl,-Bdynamic'
    LIBSCALAPACK: '-Wl,-Bstatic -Wl,--start-group -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_intel_lp64 -lmkl_sequential -lmkl_core -Wl,--end-group -Wl,-Bdynamic'
    LIBSCALAPACK_MT: '-Wl,-Bstatic -Wl,--start-group -lmkl_scalapack_lp64 -lmkl_blacs_intelmpi_lp64 -lmkl_intel_lp64 -lmkl_intel_thread -lmkl_core -Wl,--end-group -Wl,-Bdynamic'

  # A template to set the mpsd_release
  mpsd_release: &mpsd_release
    mpsd_release: '24a'

  # A template for all the sandybridge builders
  spack_builder: &spack_builder
    <<: *mpsd_release
    workers:
      - !WorkerGroup 'tentacles'

  # A template for spack mpi builders
  mpi_builder: &mpi_builder
    <<: *spack_builder
    var: &mpi_builder_var
      <<: [*spack_env_vars_libs, *spack_env_vars_libs_mpi]
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -lgomp"
      CFLAGS: '{foss.cflags}'
      CXXFLAGS: '{foss.cxxflags}'
      FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 8
      MPIEXEC: 'orterun --map-by socket'
      CC: 'mpicc'
      CXX: 'mpicxx'
      FC: 'mpif90'
    flags: '{spack.configure_flags_mpi}'
    mpi: True
    codeCoverage: True

  # A template for spack mpi min builders
  mpi_min_builder: &mpi_min_builder
    <<: *spack_builder
    var: &mpi_min_builder_var
      <<: [*spack_env_vars_libs, *spack_env_vars_libs_mpi]
      CFLAGS: '{foss.cflags}'
      CXXFLAGS: '{foss.cxxflags}'
      FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 8
      MPIEXEC: 'orterun --map-by socket'
      CC: 'mpicc'
      CXX: 'mpicxx'
      FC: 'mpif90'
    flags: '{spack.configure_flags_mpi_min}'
    mpi: True
    codeCoverage: True
    variant: 'min'

  # A template for spack mpi_omp builders
  mpi_omp_builder: &mpi_omp_builder
    <<: *spack_builder
    var: &mpi_omp_builder_var
      <<: [*spack_env_vars_libs, *spack_env_vars_libs_mpi]
      CFLAGS: '{foss.cflags_mt}'
      CXXFLAGS: '{foss.cxxflags_mt}'
      FCFLAGS: '{foss.fflags_mt}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 4
      MPIEXEC: 'orterun --map-by socket'
      OMP_NUM_THREADS: 2
      CC: 'mpicc'
      CXX: 'mpicxx'
      FC: 'mpif90'
    flags: '{spack.configure_flags_mpi_omp}'
    mpi: True

  # A template for spack mpi_debug builders
  mpi_debug_builder: &mpi_debug_builder
    <<: *spack_builder
    var: &mpi_debug_builder_var
      <<: [*spack_env_vars_libs, *spack_env_vars_libs_mpi]
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -lgomp"
      CFLAGS: '{foss.cflags_debug}'
      CXXFLAGS: '{foss.cxxflags_debug}'
      CPPFLAGS: '-DINIT_BATCH'
      FCFLAGS: '{foss.fflags_debug_mpi} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 8
      MPIEXEC: 'orterun --map-by socket'
      OCT_DEBUGTRAPSIGNALS : 'no'
      CC: 'mpicc'
      CXX: 'mpicxx'
      FC: 'mpif90'
    flags: '{spack.configure_flags_mpi}'
    mpi: True
    codeCoverage: True

  # A template for spack mpi_opt builders
  mpi_opt_builder: &mpi_opt_builder
    <<: *spack_builder
    var: &mpi_opt_builder_var
      <<: [*spack_env_vars_libs, *spack_env_vars_libs_mpi]
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -lgomp"
      CFLAGS: '{foss.cflags_opt}'
      CXXFLAGS: '{foss.cxxflags_opt}'
      FCFLAGS: '{foss.fflags_opt} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 8
      MPIEXEC: 'orterun --map-by socket'
      CC: 'mpicc'
      CXX: 'mpicxx'
      FC: 'mpif90'
    flags: '{spack.configure_flags_mpi}'
    mpi: True

  mpi_warnings_builder: &mpi_warnings_builder
    <<: *spack_builder
    var: &mpi_warnings_builder_var
      <<: [*spack_env_vars_libs, *spack_env_vars_libs_mpi]
      CFLAGS: '{foss.cflags_warnings}'
      CXXFLAGS: '{foss.cxxflags_warnings}'
      FCFLAGS: '{foss.fflags_warnings} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16 -s'
      LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
      CC: 'mpicc'
      CXX: 'mpicxx'
      FC: 'mpif90'
    flags: '{spack.configure_flags_mpi}'
    mpi: True
    test: 'none'
    variant: 'warnings'
    failOnCompilerWarnings: True

  # A template for spack serial builders
  serial_builder: &serial_builder
    <<: *spack_builder
    var:
      <<: *spack_env_vars_libs
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -lgomp"
      CFLAGS: '{foss.cflags}'
      CXXFLAGS: '{foss.cxxflags}'
      FCFLAGS: '{foss.fflags}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 16
      CC: 'gcc'
      CXX: 'g++'
      FC: 'gfortran'
    flags: '{spack.configure_flags_serial}'
    mpi: False
    codeCoverage: True

  # A template for spack serial_min builders
  serial_min_builder: &serial_min_builder
    <<: *spack_builder
    var:
      <<: *spack_env_vars_libs
      CFLAGS: '{foss.cflags}'
      CXXFLAGS: '{foss.cxxflags}'
      FCFLAGS: '{foss.fflags}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 16
      CC: 'gcc'
      CXX: 'g++'
      FC: 'gfortran'
    flags: '{spack.configure_flags_serial_min}'
    mpi: False
    codeCoverage: True
    variant: 'min'

  # A template for spack distcheck builders
  distcheck_builder: &distcheck_builder
    <<: *serial_min_builder
    var:
      <<: *spack_env_vars_libs
      CFLAGS: '-O0'
      CXXFLAGS: '-O0'
      FCFLAGS: '-O0 -DSHARE_DIR="/tmp/"'
      LOCAL_MAKEFLAGS: '-j 16'
      CC: 'gcc'
      CXX: 'g++'
      FC: 'gfortran'
    flags: '{spack.configure_flags_serial_min} --prefix=/tmp/ '
    variant: 'min'
    test: 'distcheck'
    codeCoverage: False


  # A template for spack serial_omp builders
  serial_omp_builder: &serial_omp_builder
    <<: *spack_builder
    var:
      <<: *spack_env_vars_libs
      CFLAGS: '{foss.cflags_mt}'
      CXXFLAGS: '{foss.cxxflags_mt}'
      FCFLAGS: '{foss.fflags_mt}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 8
      OMP_NUM_THREADS: 2
      CC: 'gcc'
      CXX: 'g++'
      FC: 'gfortran'
    flags: '{spack.configure_flags_serial_omp}'
    mpi: False

  # A template for spack serial_debug builders
  serial_debug_builder: &serial_debug_builder
    <<: *spack_builder
    var:
      <<: *spack_env_vars_libs
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -lgomp"
      CFLAGS: '{foss.cflags_debug}'
      CXXFLAGS: '{foss.cxxflags_debug}'
      FCFLAGS: '{foss.fflags_debug}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 16
      OCT_DEBUGTRAPSIGNALS : 'no'
      CC: 'gcc'
      CXX: 'g++'
      FC: 'gfortran'
    flags: '{spack.configure_flags_serial} --with-dftbplus-prefix=' # TODO: try --without-dftbplus and then --with-dftbplus-prefix=no instead
    mpi: False
    codeCoverage: True

  # A template for spack serial_opt builders
  serial_opt_builder: &serial_opt_builder
    <<: *spack_builder
    var:
      <<: *spack_env_vars_libs
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -lgomp"
      CFLAGS: '{foss.cflags_opt}'
      CXXFLAGS: '{foss.cxxflags_opt}'
      FCFLAGS: '{foss.fflags_opt}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 16
      CC: 'gcc'
      CXX: 'g++'
      FC: 'gfortran'
    flags: '{spack.configure_flags_serial}'
    mpi: False
    codeCoverage: False  # Check with Martin Leuders why?

  # A template for spack serial_warnings builders
  serial_warnings_builder: &serial_warnings_builder
    <<: *spack_builder
    var: &serial_warnings_builder_var
      <<: *spack_env_vars_libs
      CFLAGS: '{foss.cflags_warnings}'
      CXXFLAGS: '{foss.cxxflags_warnings}'
      FCFLAGS: '{foss.fflags_warnings}'
      LOCAL_MAKEFLAGS: '-j 16 -s'
      LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
      CC: 'gcc'
      CXX: 'g++'
      FC: 'gfortran'
    flags: '{spack.configure_flags_serial}'
    test: 'none'
    variant: 'warnings'
    failOnCompilerWarnings: True

  # A template for spack cuda mpi omp builders
  cuda_mpi_omp_builder: &cuda_mpi_omp_builder
    <<: *mpsd_release
    workers:
      - !WorkerGroup 'accelerated_tentacles'
    var:
      <<: [*spack_env_vars_libs, *spack_env_vars_libs_mpi]
      CFLAGS: '{foss.cflags_mt}'
      CXXFLAGS: '{foss.cxxflags_mt}'
      FCFLAGS: '{foss.fflags_mt} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 20'
      OCT_TEST_NJOBS: 10
      OMP_NUM_THREADS: 2
      MPIEXEC: 'orterun --map-by socket'
      CC: 'mpicc'
      CXX: 'mpicxx'
      FC: 'mpif90'
    flags: '{spack.cuda_configure_flags_mpi_mt}'
    mpi: True
    cuda: True

  # A template for cuda serial builders
  cuda_serial_builder: &cuda_serial_builder
    <<: *mpsd_release
    workers:
      - !WorkerGroup 'accelerated_tentacles'
    var:
      <<: *spack_env_vars_libs
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -lgomp"
      CFLAGS: '{foss.cflags}'
      CXXFLAGS: '{foss.cxxflags}'
      FCFLAGS: '{foss.fflags} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 20
      CC: 'gcc'
      CXX: 'g++'
      FC: 'gfortran'
    flags: '{spack.cuda_configure_flags_serial}'
    cuda: True
    codeCoverage: True

  # A template for spack valgrind builders
  valgrind_builder: &valgrind_builder
    <<: *mpsd_release
    workers:
      - !WorkerGroup 'fat_tentacles'
    var:
      <<: *spack_env_vars_libs
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -lgomp"
      CFLAGS: '{foss.cflags_debug}'
      CXXFLAGS: '{foss.cxxflags_debug}'
      FCFLAGS: '{foss.fflags_valgrind}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 32
      OMP_NUM_THREADS: 1
      LIBBLAS: '-lopenblas'
      CC: 'gcc'
      CXX: 'g++'
      FC: 'gfortran'
    flags: '{spack.configure_flags_valgrind} --without-cgal  --without-dftbplus'
    test: 'short'
    valgrind: True
    codeCoverage: False  # TODO: enable code coverage for valgrind builders

  # A template for spack ppc builders
  ppc_builder: &ppc_builder
    <<: *mpsd_release
    workers:
      - !WorkerGroup 'power_tentacles'
    var:
      <<: *spack_env_vars_libs
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -lgomp"
      CFLAGS: '{foss.ppc_cflags} -ffree-line-length-none'
      CXXFLAGS: '{foss.ppc_cxxflags} -ffree-line-length-none'
      FCFLAGS: '{foss.ppc_fflags} -ffree-line-length-none'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 16
    flags: '{spack.configure_flags_ppc}'

    # a template for intel builders
  intel_serial: &intel_serial_builder
    <<: *spack_builder
    var: &intel_serial_var
      <<: *spack_intel_env_vars_libs
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -liomp"
      CFLAGS: '{intel.cflags}'
      CXXFLAGS: '{intel.cxxflags}'
      FCFLAGS: '{intel.fflags}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 16
    flags: '{intel.configure_flags_serial} --with-nfft=$MPSD_NFFT_ROOT'

  # A template for intel serial performance builders
  intel_serial_perf: &intel_serial_perf_builder
    <<: *intel_serial_builder
    workers:
      - !WorkerGroup 'pseudopods'
    var:
      <<: *intel_serial_var
      FCCPP: 'cpp'
      # FCFLAGS_FFTW: '-I${MPSD_'
      SLURM: 'true'
      NODES: 2
      TASKS: 64
    test: 'none'

  # A template for intel mpi builders
  intel_impi: &intel_impi_builder
    <<: *spack_builder
    var: &intel_impi_var
      <<: [*spack_intel_env_vars_libs , *spack_intel_env_vars_libs_mpi]
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -liomp"
      CFLAGS: '{intel.cflags}'
      CXXFLAGS: '{intel.cxxflags}'
      FCFLAGS: '{intel.fflags} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 8
      MPIEXEC: 'mpirun --map-by socket'
      CC: 'mpiicc'
      CXX: 'mpiicpc'
      FC: 'mpiifort'
    flags: '{intel.configure_flags_mpi}'
    mpi: True

  # A template for intel mpi performance builders
  intel_impi_perf: &intel_impi_perf_builder
    <<: *intel_impi_builder
    workers:
      - !WorkerGroup 'pseudopods'
    var: &intel_impi_perf_var
      <<: *intel_impi_var

      FCCPP: 'cpp'
      SLURM: 'true'
      NODES: 2
      TASKS: 64
      NPROC: 2
    test: 'none'

  intel_serial_omp: &intel_serial_omp_builder
    <<: *spack_builder
    var:
      <<: *spack_intel_env_vars_libs
      CFLAGS: '{intel.cflags}'
      CXXFLAGS: '{intel.cxxflags}'
      FCFLAGS: '{intel.fflags}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 8
      OMP_NUM_THREADS : 2
    flags: '{intel.configure_flags_mt} --with-nfft=$MPSD_NFFT_ROOT'

  intel_impi_omp: &interl_impi_omp_builder
    <<: *spack_builder
    var: &intel_impi_omp_var
      <<: [*spack_intel_env_vars_libs , *spack_intel_env_vars_libs_mpi]
      CFLAGS: '{intel.cflags}'
      CXXFLAGS: '{intel.cxxflags}'
      FCFLAGS: '{intel.fflags} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 4
      OMP_NUM_THREADS: 2
      CC: 'mpiicc'
      CXX: 'mpiicpc'
      FC: 'mpiifort'
      MPIEXEC: 'mpirun --map-by socket'
    flags: '{intel.configure_flags_mpi_mt}'
    mpi: True

  intel_serial_debug: &intel_debug_builder
    <<: *spack_builder
    var:
      <<: *spack_intel_env_vars_libs
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -liomp"
      CFLAGS: '{intel.cflags_debug}'
      CXXFLAGS: '{intel.cxxflags_debug}'
      FCFLAGS: '{intel.fflags_debug}'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 16
      OCT_DEBUGTRAPSIGNALS : 'no'
    flags: '{intel.configure_flags_serial} --with-nfft=$MPSD_NFFT_ROOT --with-dftbplus-prefix="disable"'

  intel_impi_debug: &intel_impi_debug_builder
    <<: *spack_builder
    var:
      <<: [*spack_intel_env_vars_libs , *spack_intel_env_vars_libs_mpi]
      LIBS_BERKELEYGW: "-L${MPSD_BERKELEYGW_ROOT}/lib -lBGW_wfn -liomp"
      CFLAGS: '{intel.cflags_debug}'
      CXXFLAGS: '{intel.cxxflags_debug}'
      FCFLAGS: '{intel.fflags_debug} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16'
      OCT_TEST_NJOBS: 8
      OCT_DEBUGTRAPSIGNALS : 'no'
      MPIEXEC: 'mpirun --map-by socket'
      CC: 'mpiicc'
      CXX: 'mpiicpc'
      FC: 'mpiifort'
    flags: '{intel.configure_flags_mpi}'
    mpi: True

  # A template for spack intel serial_warnings builders
  intel_serial_warnings_builder: &intel_serial_warnings_builder
    <<: *spack_builder
    var:
      <<: *spack_intel_env_vars_libs
      CFLAGS: '{intel.cflags_warnings}'
      CXXFLAGS: '{intel.cxxflags_warnings}'
      FCFLAGS: '{intel.fflags_warnings}'
      LOCAL_MAKEFLAGS: '-j 16 -s'
      LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
    flags: '{intel.configure_flags_serial} --with-sparskit=-L"$MPSD_SPARSKIT_ROOT/lib"'
    test: 'none'
    variant: 'warnings'
    failOnCompilerWarnings: True

  intel_mpi_warnings_builder: &intel_mpi_warnings_builder
    <<: *spack_builder
    var: &intel_mpi_warnings_builder_var
      <<: [*spack_intel_env_vars_libs, *spack_intel_env_vars_libs_mpi]
      CFLAGS: '{intel.cflags_warnings}'
      CXXFLAGS: '{intel.cxxflags_warnings}'
      FCFLAGS: '{intel.fflags_warnings} -fallow-argument-mismatch'
      LOCAL_MAKEFLAGS: '-j 16 -s'
      LDFLAGS_EXTRA: '-Wl,--no-warn-execstack'
      CC: 'mpiicc'
      CXX: 'mpiicpc'
      FC: 'mpiifort'
    flags: '{intel.configure_flags_mpi} --with-sparskit=-L"$MPSD_SPARSKIT_ROOT/lib"'
    mpi: True
    test: 'none'
    variant: 'warnings'
    failOnCompilerWarnings: True

SPACK:
  foss:
    # ---- MPI Builders ----

    2022a_mpi:
      <<: *mpi_builder
      var:
        <<: *mpi_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2021.11.001/modules'
    2022b_mpi:
      <<: *mpi_builder
      var:
        <<: *mpi_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2022.11.001/modules'
    2023a_mpi:
      <<: *mpi_builder
      var:
        <<: *mpi_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.05.001/modules'
    2023b_mpi:
      <<: *mpi_builder
      var:
        <<: *mpi_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.11.001/modules'

    # ---- MPI min Builders ----

    2022a_mpi_min:
      <<: *mpi_min_builder
      var:
        <<: *mpi_min_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2021.11.001/modules'
    2022b_mpi_min:
      <<: *mpi_min_builder
      var:
        <<: *mpi_min_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2022.11.001/modules'
    2023a_mpi_min:
      <<: *mpi_min_builder
      var:
        <<: *mpi_min_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.05.001/modules'
    2023b_mpi_min:
      <<: *mpi_min_builder
      var:
        <<: *mpi_min_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.11.001/modules'



    # ---- MPI OMP Builders ----
    2022a_mpi_omp:
      <<: *mpi_omp_builder
      var:
        <<: *mpi_omp_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2021.11.001/modules'
    2022b_mpi_omp:
      <<: *mpi_omp_builder
      var:
        <<: *mpi_omp_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2022.11.001/modules'
    2023a_mpi_omp:
      <<: *mpi_omp_builder
      var:
        <<: *mpi_omp_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2023.05.001/modules'
    2023b_mpi_omp:
      <<: *mpi_omp_builder
      var:
        <<: *mpi_omp_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2023.11.001/modules'


    # ---- MPI Debug Builders ----
    2022a_mpi_debug:
      <<: *mpi_debug_builder
      var:
        <<: *mpi_debug_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2021.11.001/modules'
    2022b_mpi_debug:
      <<: *mpi_debug_builder
      var:
        <<: *mpi_debug_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2022.11.001/modules'
    2023a_mpi_debug:
      <<: *mpi_debug_builder
      var:
        <<: *mpi_debug_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.05.001/modules'
    2023b_mpi_debug:
      <<: *mpi_debug_builder
      var:
        <<: *mpi_debug_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.11.001/modules'


    # ---- MPI OPT Builders ----
    2022a_mpi_opt:
      <<: *mpi_opt_builder
      var:
        <<: *mpi_opt_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2021.11.001/modules'
    2022b_mpi_opt:
      <<: *mpi_opt_builder
      var:
        <<: *mpi_opt_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2022.11.001/modules'
    2023a_mpi_opt:
      <<: *mpi_opt_builder
      var:
        <<: *mpi_opt_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.05.001/modules'
    2023b_mpi_opt:
      <<: *mpi_opt_builder
      var:
        <<: *mpi_opt_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.11.001/modules'

    # ---- MPI WARNINGS Builders ----
    2022a_warnings_mpi:
      <<: *mpi_warnings_builder
      var:
        <<: *mpi_warnings_builder_var
        LDFLAGS_EXTRA: ''
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2021.11.001/modules'
    2022b_warnings_mpi:
      <<: *mpi_warnings_builder
      var:
        <<: *mpi_warnings_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2022.11.001/modules'
    2023a_warnings_mpi:
      <<: *mpi_warnings_builder
      var:
        <<: *mpi_warnings_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.05.001/modules'
    2023b_warnings_mpi:
      <<: *mpi_warnings_builder
      var:
        <<: *mpi_warnings_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.11.001/modules'

    # ---- Serial Builders ----
    2022a_serial:
      <<: *serial_builder
    2022b_serial:
      <<: *serial_builder
    2023a_serial:
      <<: *serial_builder
    2023b_serial:
      <<: *serial_builder

    # ---- Serial MIN Builders ----
    2022a_serial_min:
      <<: *serial_min_builder
    2022b_serial_min:
      <<: *serial_min_builder
    2023a_serial_min:
      <<: *serial_min_builder
    2023b_serial_min:
      <<: *serial_min_builder


    # ---- Distcheck  Builders ----
    # Dist check builders are same as the serial min builders
    # with test = distcheck
    2022a_distcheck:
      <<: *distcheck_builder
    2022b_distcheck:
      <<: *distcheck_builder
    2023a_distcheck:
      <<: *distcheck_builder
    2023b_distcheck:
      <<: *distcheck_builder

    # ---- Serial OMP Builders ----

    2022a_serial_omp:
      <<: *serial_omp_builder
    2022b_serial_omp:
      <<: *serial_omp_builder
    2023a_serial_omp:
      <<: *serial_omp_builder
    2023b_serial_omp:
      <<: *serial_omp_builder

    # ---- Serial Debug Builders ----

    2022a_serial_debug:
      <<: *serial_debug_builder
    2022b_serial_debug:
      <<: *serial_debug_builder
    2023a_serial_debug:
      <<: *serial_debug_builder
    2023b_serial_debug:
      <<: *serial_debug_builder

    2022a_serial_opt:
      <<: *serial_opt_builder
    2022b_serial_opt:
      <<: *serial_opt_builder
    2023a_serial_opt:
      <<: *serial_opt_builder
    2023b_serial_opt:
      <<: *serial_opt_builder

    # ---- Serial WARNINGS Builders ----
    2022a_warnings_serial:
      <<: *serial_warnings_builder
      var:
        <<: *serial_warnings_builder_var
        LDFLAGS_EXTRA: ''
    2022b_warnings_serial:
      <<: *serial_warnings_builder
    2023a_warnings_serial:
      <<: *serial_warnings_builder
    2023b_warnings_serial:
      <<: *serial_warnings_builder

    # ---- Cuda Builders ----
    2022a_cuda_mpi_omp:
      <<: *cuda_mpi_omp_builder
    # no cuda higher than 22a as we are still on debian 11.

    2022a_cuda_serial:
      <<: *cuda_serial_builder

    # ---- Valgrind Builders ----
    2022a_valgrind:
      <<: *valgrind_builder
    2022b_valgrind:
      <<: *valgrind_builder
    2023a_valgrind:
      <<: *valgrind_builder
    2023b_valgrind:
      <<: *valgrind_builder

    # ---- PPC Builders ----

    2022a_ppc:
      <<: *ppc_builder
    2022b_ppc:
      <<: *ppc_builder
    2023a_ppc:
      <<: *ppc_builder
    2023b_ppc:
      <<: *ppc_builder



  intel:
    # ---- Serial Builders ----
    2022a_serial:
      <<: *intel_serial_builder
    2022b_serial:
      <<: *intel_serial_builder
    2023a_serial:
      <<: *intel_serial_builder
    2023a_debug:
      <<: *intel_debug_builder
    2023b_serial:
      <<: *intel_serial_builder
    # ---- MPI Builders ----
    2022a_impi:
      <<: *intel_impi_builder
      var:
        <<: *intel_impi_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2021.11.001/modules'
    2022b_impi:
      <<: *intel_impi_builder
      var:
        <<: *intel_impi_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2022.11.001/modules'
    2023a_impi:
      <<: *intel_impi_builder
      var:
        <<: *intel_impi_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.05.001/modules'
    2023a_impi_debug:
      <<: *intel_impi_debug_builder
      var:
        <<: *intel_impi_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.05.001/modules'
    2023b_impi:
      <<: *intel_impi_builder
      var:
        <<: *intel_impi_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.11.001/modules'

    # ---- Serial OMP Builders ----
    2022a_serial_omp:
      <<: *intel_serial_omp_builder
    2022b_serial_omp:
      <<: *intel_serial_omp_builder
    2023a_serial_omp:
      <<: *intel_serial_omp_builder
    2023b_serial_omp:
      <<: *intel_serial_omp_builder

    # ---- MPI OMP Builders ----
    2022a_impi_omp:
      <<: *interl_impi_omp_builder
      var:
        <<: *intel_impi_omp_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2021.11.001/modules'
    2022b_impi_omp:
      <<: *interl_impi_omp_builder
      var:
        <<: *intel_impi_omp_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2022.11.001/modules'
    2023a_impi_omp:
      <<: *interl_impi_omp_builder
      var:
        <<: *intel_impi_omp_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2023.05.001/modules'
    2023b_impi_omp:
      <<: *interl_impi_omp_builder
      var:
        <<: *intel_impi_omp_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2023.11.001/modules'

    # ---- Intel performance builders ----
    2022a_serial_perf:
      <<: *intel_serial_perf_builder
    2022b_serial_perf:
      <<: *intel_serial_perf_builder
    2023a_serial_perf:
      <<: *intel_serial_perf_builder
    2023b_serial_perf:
      <<: *intel_serial_perf_builder

    2022a_impi_perf:
      <<: *intel_impi_perf_builder
      var:
        <<: *intel_impi_perf_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2021.11.001/modules'
    2022b_impi_perf:
      <<: *intel_impi_perf_builder
      var:
        <<: *intel_impi_perf_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2022.11.001/modules'
    2023a_impi_perf:
      <<: *intel_impi_perf_builder
      var:
        <<: *intel_impi_perf_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2023.05.001/modules'
    2023b_impi_perf:
      <<: *intel_impi_perf_builder
      var:
        <<: *intel_impi_perf_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa_openmp-2023.11.001/modules'

    # ---- Serial WARNINGS Builders ----
    2022a_warnings_serial:
      <<: *intel_serial_warnings_builder
    2022b_warnings_serial:
      <<: *intel_serial_warnings_builder
    2023a_warnings_serial:
      <<: *intel_serial_warnings_builder
    2023b_warnings_serial:
      <<: *intel_serial_warnings_builder

    # ---- MPI WARNINGS Builders ----
    2022a_warnings_mpi:
      <<: *intel_mpi_warnings_builder
      var:
        <<: *intel_mpi_warnings_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2021.11.001/modules'
    2022b_warnings_mpi:
      <<: *intel_mpi_warnings_builder
      var:
        <<: *intel_mpi_warnings_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2022.11.001/modules'
    2023a_warnings_mpi:
      <<: *intel_mpi_warnings_builder
      var:
        <<: *intel_mpi_warnings_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.05.001/modules'
    2023b_warnings_mpi:
      <<: *intel_mpi_warnings_builder
      var:
        <<: *intel_mpi_warnings_builder_var
        FCFLAGS_ELPA: '-I${MPSD_ELPA_ROOT}/include/elpa-2023.11.001/modules'
